Due to a recent update on Javascript code a full page refresh on your browser might be needed.
Bug 479995 - Enable SHA2 file digests in RPMs
Summary: Enable SHA2 file digests in RPMs
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: distribution
Version: 6.0
Hardware: All
OS: Linux
medium
medium
Target Milestone: rc
: 6.0
Assignee: RHEL Program Management
QA Contact: Daniel Riek
URL:
Whiteboard:
Depends On: 479869 479990
Blocks: 477043
TreeView+ depends on / blocked
 
Reported: 2009-01-14 14:43 UTC by Miloslav Trmač
Modified: 2013-01-10 05:00 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of: 479990
Environment:
Last Closed: 2009-05-29 19:09:56 UTC
Target Upstream Version:


Attachments (Terms of Use)

Description Miloslav Trmač 2009-01-14 14:43:00 UTC
+++ This bug was initially created as a clone of Bug #479990 +++

RPMs in RHEL currently use MD5 to verify contents of installed files during package installation and (rpm -V).  MD5 has significant weaknesses, and should be replaced by a stronger hash.  See https://fedoraproject.org/wiki/Features/StrongerHashes for more rationale and information.

To enable SHA-256, define the following macros in the build environment:
_source_filedigest_algorithm 8
_binary_filedigest_algorithm 8

This depends on #479869 - RPM currently does not handle updates that change the used digest algorithm correctly.

Another dependency is koji#119 (and updating brew to match): brew currently cannot handle RPMs that use digest algorithms with larger output than MD5.

The configuration replaces the RPMTAG_FILEDIGESTS==RPMTAG_FILEMD5S contents by a non-MD5 hash, which can break tools that work with the rpm file format directly (whether using librpm or not).  Linux Standard Base specifies that the tag contains MD5 hashes, but the RHEL package format does not have to conform to LSB for the same reason package contents do not have to conform to LSB: we only need to be able to handle LSB packages correctly.

To ensure full system integrity protection, all packages have to be rebuilt after changing the build configuration (or perhaps the other way, the build configuration should be changed before the mass rebuild).


Note You need to log in before you can comment on or make changes to this bug.